uniform sampler2D base;
uniform sampler2D bump;
uniform sampler2D height;
varying vec3 eyeVec;
varying vec3 lightVec;

void main()
{
	vec2 sb = vec2(0.004,0.02);
	float height = texture2D(height , gl_TexCoord[0].st).r;
	float v = height * sb.r - sb.g;
	vec3 eye = normalize(eyeVec);
	vec2 newCoords = gl_TexCoord[0].st + (v * eye.xy);
	
	vec3 norm = texture2D(bump, gl_TexCoord[0].st).rgb * 2.0 - 1.0;
	vec4 baseColor = texture2D(base,newCoords);

	float dist = length(lightVec);
//	float att = 1.0;
	//float att = 1.0 / (gl_LightSource[1].constantAttenuation +
	//gl_LightSource[1].linearAttenuation * dist +
	//gl_LightSource[1].quadraticAttenuation * dist * dist);
	float att = 1.0;

    vec4 final_color = (gl_FrontLightModelProduct.sceneColor * gl_FrontMaterial.ambient) + 
			(gl_LightSource[1].ambient * gl_FrontMaterial.ambient * att);
							
	vec3 lightVector = normalize(lightVec);
	float nxDir = max(0.0, dot(norm, lightVector));
	float specularPower = 0.0;
	if(nxDir != 0.0)
	{
		final_color += gl_LightSource[1].diffuse * gl_FrontMaterial.diffuse * nxDir * att;	
		vec3 cameraVector = eyeVec;
	
		vec3 halfVector = normalize(lightVector + cameraVector);
		float nxHalf = max(0.0,dot(norm, halfVector));
		specularPower = pow(nxHalf, gl_FrontMaterial.shininess);
	}
	final_color += gl_LightSource[1].specular * gl_FrontMaterial.specular * specularPower * att;	
	gl_FragColor =  baseColor * final_color;
}
