uniform sampler2D texture;

varying vec3 eyeVec, lightDir, normal;
void main()
{

	float dist = length(lightDir);
	float att = 1.0 / (gl_LightSource[1].constantAttenuation +
	gl_LightSource[1].linearAttenuation * dist +
	gl_LightSource[1].quadraticAttenuation * dist * dist);

    vec4 final_color = (gl_FrontLightModelProduct.sceneColor * gl_FrontMaterial.ambient) + 
			(gl_LightSource[1].ambient * gl_FrontMaterial.ambient * att);

	vec3 N = normalize(normal);
	vec3 L = normalize(lightDir);
	
	float lambertTerm = dot(N,L);
			
	if(lambertTerm > 0.0)
	{
		final_color += gl_LightSource[1].diffuse * gl_FrontMaterial.diffuse * lambertTerm * att;	
		
		vec3 E = normalize(eyeVec);
		vec3 R = reflect(-L, N);
		float specular = pow( max(dot(R, E), 0.0), gl_FrontMaterial.shininess );
		final_color += gl_LightSource[1].specular * gl_FrontMaterial.specular * specular * att;	
	}
	
	gl_FragColor = final_color*texture2D(texture, gl_TexCoord[0].xy);
}